/*******************************************************************************
* File Name: AdcISR.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_AdcISR_H)
#define CY_ISR_AdcISR_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void AdcISR_Start(void);
void AdcISR_StartEx(cyisraddress address);
void AdcISR_Stop(void);

CY_ISR_PROTO(AdcISR_Interrupt);

void AdcISR_SetVector(cyisraddress address);
cyisraddress AdcISR_GetVector(void);

void AdcISR_SetPriority(uint8 priority);
uint8 AdcISR_GetPriority(void);

void AdcISR_Enable(void);
uint8 AdcISR_GetState(void);
void AdcISR_Disable(void);

void AdcISR_SetPending(void);
void AdcISR_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the AdcISR ISR. */
#define AdcISR_INTC_VECTOR            ((reg32 *) AdcISR__INTC_VECT)

/* Address of the AdcISR ISR priority. */
#define AdcISR_INTC_PRIOR             ((reg8 *) AdcISR__INTC_PRIOR_REG)

/* Priority of the AdcISR interrupt. */
#define AdcISR_INTC_PRIOR_NUMBER      AdcISR__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable AdcISR interrupt. */
#define AdcISR_INTC_SET_EN            ((reg32 *) AdcISR__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the AdcISR interrupt. */
#define AdcISR_INTC_CLR_EN            ((reg32 *) AdcISR__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the AdcISR interrupt state to pending. */
#define AdcISR_INTC_SET_PD            ((reg32 *) AdcISR__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the AdcISR interrupt. */
#define AdcISR_INTC_CLR_PD            ((reg32 *) AdcISR__INTC_CLR_PD_REG)


#endif /* CY_ISR_AdcISR_H */


/* [] END OF FILE */
