/*******************************************************************************
* File Name: Agnd.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Agnd_H) /* Pins Agnd_H */
#define CY_PINS_Agnd_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Agnd_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Agnd__PORT == 15 && ((Agnd__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    Agnd_Write(uint8 value) ;
void    Agnd_SetDriveMode(uint8 mode) ;
uint8   Agnd_ReadDataReg(void) ;
uint8   Agnd_Read(void) ;
uint8   Agnd_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Agnd_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Agnd_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Agnd_DM_RES_UP          PIN_DM_RES_UP
#define Agnd_DM_RES_DWN         PIN_DM_RES_DWN
#define Agnd_DM_OD_LO           PIN_DM_OD_LO
#define Agnd_DM_OD_HI           PIN_DM_OD_HI
#define Agnd_DM_STRONG          PIN_DM_STRONG
#define Agnd_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Agnd_MASK               Agnd__MASK
#define Agnd_SHIFT              Agnd__SHIFT
#define Agnd_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Agnd_PS                     (* (reg8 *) Agnd__PS)
/* Data Register */
#define Agnd_DR                     (* (reg8 *) Agnd__DR)
/* Port Number */
#define Agnd_PRT_NUM                (* (reg8 *) Agnd__PRT) 
/* Connect to Analog Globals */                                                  
#define Agnd_AG                     (* (reg8 *) Agnd__AG)                       
/* Analog MUX bux enable */
#define Agnd_AMUX                   (* (reg8 *) Agnd__AMUX) 
/* Bidirectional Enable */                                                        
#define Agnd_BIE                    (* (reg8 *) Agnd__BIE)
/* Bit-mask for Aliased Register Access */
#define Agnd_BIT_MASK               (* (reg8 *) Agnd__BIT_MASK)
/* Bypass Enable */
#define Agnd_BYP                    (* (reg8 *) Agnd__BYP)
/* Port wide control signals */                                                   
#define Agnd_CTL                    (* (reg8 *) Agnd__CTL)
/* Drive Modes */
#define Agnd_DM0                    (* (reg8 *) Agnd__DM0) 
#define Agnd_DM1                    (* (reg8 *) Agnd__DM1)
#define Agnd_DM2                    (* (reg8 *) Agnd__DM2) 
/* Input Buffer Disable Override */
#define Agnd_INP_DIS                (* (reg8 *) Agnd__INP_DIS)
/* LCD Common or Segment Drive */
#define Agnd_LCD_COM_SEG            (* (reg8 *) Agnd__LCD_COM_SEG)
/* Enable Segment LCD */
#define Agnd_LCD_EN                 (* (reg8 *) Agnd__LCD_EN)
/* Slew Rate Control */
#define Agnd_SLW                    (* (reg8 *) Agnd__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Agnd_PRTDSI__CAPS_SEL       (* (reg8 *) Agnd__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Agnd_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Agnd__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Agnd_PRTDSI__OE_SEL0        (* (reg8 *) Agnd__PRTDSI__OE_SEL0) 
#define Agnd_PRTDSI__OE_SEL1        (* (reg8 *) Agnd__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Agnd_PRTDSI__OUT_SEL0       (* (reg8 *) Agnd__PRTDSI__OUT_SEL0) 
#define Agnd_PRTDSI__OUT_SEL1       (* (reg8 *) Agnd__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Agnd_PRTDSI__SYNC_OUT       (* (reg8 *) Agnd__PRTDSI__SYNC_OUT) 


#if defined(Agnd__INTSTAT)  /* Interrupt Registers */

    #define Agnd_INTSTAT                (* (reg8 *) Agnd__INTSTAT)
    #define Agnd_SNAP                   (* (reg8 *) Agnd__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Agnd_H */


/* [] END OF FILE */
