/*******************************************************************************
* File Name: Ck2.h  
* Version 1.60
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_Ck2_H) /* Pins Ck2_H */
#define CY_PINS_Ck2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Ck2_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC5 &&\
     CYDEV_CHIP_REVISION_USED == CYDEV_CHIP_REVISION_5A_PRODUCTION &&\
	 Ck2__PORT == 15 && (Ck2__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    Ck2_Write(uint8 value) ;
void    Ck2_SetDriveMode(uint8 mode) ;
uint8   Ck2_ReadDataReg(void) ;
uint8   Ck2_Read(void) ;
uint8   Ck2_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Ck2_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Ck2_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Ck2_DM_RES_UP          PIN_DM_RES_UP
#define Ck2_DM_RES_DWN         PIN_DM_RES_DWN
#define Ck2_DM_OD_LO           PIN_DM_OD_LO
#define Ck2_DM_OD_HI           PIN_DM_OD_HI
#define Ck2_DM_STRONG          PIN_DM_STRONG
#define Ck2_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Ck2_MASK               Ck2__MASK
#define Ck2_SHIFT              Ck2__SHIFT
#define Ck2_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Ck2_PS                     (* (reg8 *) Ck2__PS)
/* Data Register */
#define Ck2_DR                     (* (reg8 *) Ck2__DR)
/* Port Number */
#define Ck2_PRT_NUM                (* (reg8 *) Ck2__PRT) 
/* Connect to Analog Globals */                                                  
#define Ck2_AG                     (* (reg8 *) Ck2__AG)                       
/* Analog MUX bux enable */
#define Ck2_AMUX                   (* (reg8 *) Ck2__AMUX) 
/* Bidirectional Enable */                                                        
#define Ck2_BIE                    (* (reg8 *) Ck2__BIE)
/* Bit-mask for Aliased Register Access */
#define Ck2_BIT_MASK               (* (reg8 *) Ck2__BIT_MASK)
/* Bypass Enable */
#define Ck2_BYP                    (* (reg8 *) Ck2__BYP)
/* Port wide control signals */                                                   
#define Ck2_CTL                    (* (reg8 *) Ck2__CTL)
/* Drive Modes */
#define Ck2_DM0                    (* (reg8 *) Ck2__DM0) 
#define Ck2_DM1                    (* (reg8 *) Ck2__DM1)
#define Ck2_DM2                    (* (reg8 *) Ck2__DM2) 
/* Input Buffer Disable Override */
#define Ck2_INP_DIS                (* (reg8 *) Ck2__INP_DIS)
/* LCD Common or Segment Drive */
#define Ck2_LCD_COM_SEG            (* (reg8 *) Ck2__LCD_COM_SEG)
/* Enable Segment LCD */
#define Ck2_LCD_EN                 (* (reg8 *) Ck2__LCD_EN)
/* Slew Rate Control */
#define Ck2_SLW                    (* (reg8 *) Ck2__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Ck2_PRTDSI__CAPS_SEL       (* (reg8 *) Ck2__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Ck2_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Ck2__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Ck2_PRTDSI__OE_SEL0        (* (reg8 *) Ck2__PRTDSI__OE_SEL0) 
#define Ck2_PRTDSI__OE_SEL1        (* (reg8 *) Ck2__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Ck2_PRTDSI__OUT_SEL0       (* (reg8 *) Ck2__PRTDSI__OUT_SEL0) 
#define Ck2_PRTDSI__OUT_SEL1       (* (reg8 *) Ck2__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Ck2_PRTDSI__SYNC_OUT       (* (reg8 *) Ck2__PRTDSI__SYNC_OUT) 


#if defined(Ck2__INTSTAT)  /* Interrupt Registers */

    #define Ck2_INTSTAT                (* (reg8 *) Ck2__INTSTAT)
    #define Ck2_SNAP                   (* (reg8 *) Ck2__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Ck2_H */

#endif
/* [] END OF FILE */
