/*******************************************************************************
* File Name: CkT.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_CkT_H) /* Pins CkT_H */
#define CY_PINS_CkT_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "CkT_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_70 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 CkT__PORT == 15 && (CkT__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    CkT_Write(uint8 value) ;
void    CkT_SetDriveMode(uint8 mode) ;
uint8   CkT_ReadDataReg(void) ;
uint8   CkT_Read(void) ;
uint8   CkT_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define CkT_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define CkT_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define CkT_DM_RES_UP          PIN_DM_RES_UP
#define CkT_DM_RES_DWN         PIN_DM_RES_DWN
#define CkT_DM_OD_LO           PIN_DM_OD_LO
#define CkT_DM_OD_HI           PIN_DM_OD_HI
#define CkT_DM_STRONG          PIN_DM_STRONG
#define CkT_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define CkT_MASK               CkT__MASK
#define CkT_SHIFT              CkT__SHIFT
#define CkT_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define CkT_PS                     (* (reg8 *) CkT__PS)
/* Data Register */
#define CkT_DR                     (* (reg8 *) CkT__DR)
/* Port Number */
#define CkT_PRT_NUM                (* (reg8 *) CkT__PRT) 
/* Connect to Analog Globals */                                                  
#define CkT_AG                     (* (reg8 *) CkT__AG)                       
/* Analog MUX bux enable */
#define CkT_AMUX                   (* (reg8 *) CkT__AMUX) 
/* Bidirectional Enable */                                                        
#define CkT_BIE                    (* (reg8 *) CkT__BIE)
/* Bit-mask for Aliased Register Access */
#define CkT_BIT_MASK               (* (reg8 *) CkT__BIT_MASK)
/* Bypass Enable */
#define CkT_BYP                    (* (reg8 *) CkT__BYP)
/* Port wide control signals */                                                   
#define CkT_CTL                    (* (reg8 *) CkT__CTL)
/* Drive Modes */
#define CkT_DM0                    (* (reg8 *) CkT__DM0) 
#define CkT_DM1                    (* (reg8 *) CkT__DM1)
#define CkT_DM2                    (* (reg8 *) CkT__DM2) 
/* Input Buffer Disable Override */
#define CkT_INP_DIS                (* (reg8 *) CkT__INP_DIS)
/* LCD Common or Segment Drive */
#define CkT_LCD_COM_SEG            (* (reg8 *) CkT__LCD_COM_SEG)
/* Enable Segment LCD */
#define CkT_LCD_EN                 (* (reg8 *) CkT__LCD_EN)
/* Slew Rate Control */
#define CkT_SLW                    (* (reg8 *) CkT__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define CkT_PRTDSI__CAPS_SEL       (* (reg8 *) CkT__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define CkT_PRTDSI__DBL_SYNC_IN    (* (reg8 *) CkT__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define CkT_PRTDSI__OE_SEL0        (* (reg8 *) CkT__PRTDSI__OE_SEL0) 
#define CkT_PRTDSI__OE_SEL1        (* (reg8 *) CkT__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define CkT_PRTDSI__OUT_SEL0       (* (reg8 *) CkT__PRTDSI__OUT_SEL0) 
#define CkT_PRTDSI__OUT_SEL1       (* (reg8 *) CkT__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define CkT_PRTDSI__SYNC_OUT       (* (reg8 *) CkT__PRTDSI__SYNC_OUT) 


#if defined(CkT__INTSTAT)  /* Interrupt Registers */

    #define CkT_INTSTAT                (* (reg8 *) CkT__INTSTAT)
    #define CkT_SNAP                   (* (reg8 *) CkT__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins CkT_H */

#endif
/* [] END OF FILE */
