/*******************************************************************************
* File Name: ClkIn.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_ClkIn_H) /* Pins ClkIn_H */
#define CY_PINS_ClkIn_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "ClkIn_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 ClkIn__PORT == 15 && ((ClkIn__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    ClkIn_Write(uint8 value) ;
void    ClkIn_SetDriveMode(uint8 mode) ;
uint8   ClkIn_ReadDataReg(void) ;
uint8   ClkIn_Read(void) ;
uint8   ClkIn_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define ClkIn_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define ClkIn_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define ClkIn_DM_RES_UP          PIN_DM_RES_UP
#define ClkIn_DM_RES_DWN         PIN_DM_RES_DWN
#define ClkIn_DM_OD_LO           PIN_DM_OD_LO
#define ClkIn_DM_OD_HI           PIN_DM_OD_HI
#define ClkIn_DM_STRONG          PIN_DM_STRONG
#define ClkIn_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define ClkIn_MASK               ClkIn__MASK
#define ClkIn_SHIFT              ClkIn__SHIFT
#define ClkIn_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define ClkIn_PS                     (* (reg8 *) ClkIn__PS)
/* Data Register */
#define ClkIn_DR                     (* (reg8 *) ClkIn__DR)
/* Port Number */
#define ClkIn_PRT_NUM                (* (reg8 *) ClkIn__PRT) 
/* Connect to Analog Globals */                                                  
#define ClkIn_AG                     (* (reg8 *) ClkIn__AG)                       
/* Analog MUX bux enable */
#define ClkIn_AMUX                   (* (reg8 *) ClkIn__AMUX) 
/* Bidirectional Enable */                                                        
#define ClkIn_BIE                    (* (reg8 *) ClkIn__BIE)
/* Bit-mask for Aliased Register Access */
#define ClkIn_BIT_MASK               (* (reg8 *) ClkIn__BIT_MASK)
/* Bypass Enable */
#define ClkIn_BYP                    (* (reg8 *) ClkIn__BYP)
/* Port wide control signals */                                                   
#define ClkIn_CTL                    (* (reg8 *) ClkIn__CTL)
/* Drive Modes */
#define ClkIn_DM0                    (* (reg8 *) ClkIn__DM0) 
#define ClkIn_DM1                    (* (reg8 *) ClkIn__DM1)
#define ClkIn_DM2                    (* (reg8 *) ClkIn__DM2) 
/* Input Buffer Disable Override */
#define ClkIn_INP_DIS                (* (reg8 *) ClkIn__INP_DIS)
/* LCD Common or Segment Drive */
#define ClkIn_LCD_COM_SEG            (* (reg8 *) ClkIn__LCD_COM_SEG)
/* Enable Segment LCD */
#define ClkIn_LCD_EN                 (* (reg8 *) ClkIn__LCD_EN)
/* Slew Rate Control */
#define ClkIn_SLW                    (* (reg8 *) ClkIn__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define ClkIn_PRTDSI__CAPS_SEL       (* (reg8 *) ClkIn__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define ClkIn_PRTDSI__DBL_SYNC_IN    (* (reg8 *) ClkIn__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define ClkIn_PRTDSI__OE_SEL0        (* (reg8 *) ClkIn__PRTDSI__OE_SEL0) 
#define ClkIn_PRTDSI__OE_SEL1        (* (reg8 *) ClkIn__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define ClkIn_PRTDSI__OUT_SEL0       (* (reg8 *) ClkIn__PRTDSI__OUT_SEL0) 
#define ClkIn_PRTDSI__OUT_SEL1       (* (reg8 *) ClkIn__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define ClkIn_PRTDSI__SYNC_OUT       (* (reg8 *) ClkIn__PRTDSI__SYNC_OUT) 


#if defined(ClkIn__INTSTAT)  /* Interrupt Registers */

    #define ClkIn_INTSTAT                (* (reg8 *) ClkIn__INTSTAT)
    #define ClkIn_SNAP                   (* (reg8 *) ClkIn__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_ClkIn_H */


/* [] END OF FILE */
