/*******************************************************************************
* File Name: ISR1.h
* Version 1.50
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/
#if !defined(__ISR1_INTC_H__)
#define __ISR1_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void ISR1_Start(void);
void ISR1_StartEx(cyisraddress address);
void ISR1_Stop(void) ;

CY_ISR_PROTO(ISR1_Interrupt);

void ISR1_SetVector(cyisraddress address) ;
cyisraddress ISR1_GetVector(void) ;

void ISR1_SetPriority(uint8 priority) ;
uint8 ISR1_GetPriority(void) ;

void ISR1_Enable(void) ;
uint8 ISR1_GetState(void) ;
void ISR1_Disable(void) ;

void ISR1_SetPending(void) ;
void ISR1_ClearPending(void) ;


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the ISR1 ISR. */
#define ISR1_INTC_VECTOR            ((reg32 *) ISR1__INTC_VECT)

/* Address of the ISR1 ISR priority. */
#define ISR1_INTC_PRIOR             ((reg8 *) ISR1__INTC_PRIOR_REG)

/* Priority of the ISR1 interrupt. */
#define ISR1_INTC_PRIOR_NUMBER      ISR1__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable ISR1 interrupt. */
#define ISR1_INTC_SET_EN            ((reg32 *) ISR1__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the ISR1 interrupt. */
#define ISR1_INTC_CLR_EN            ((reg32 *) ISR1__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the ISR1 interrupt state to pending. */
#define ISR1_INTC_SET_PD            ((reg32 *) ISR1__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the ISR1 interrupt. */
#define ISR1_INTC_CLR_PD            ((reg32 *) ISR1__INTC_CLR_PD_REG)



/* __ISR1_INTC_H__ */
#endif
