/*******************************************************************************
* File Name: LPF1.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_LPF1_H) /* Pins LPF1_H */
#define CY_PINS_LPF1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "LPF1_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 LPF1__PORT == 15 && ((LPF1__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    LPF1_Write(uint8 value) ;
void    LPF1_SetDriveMode(uint8 mode) ;
uint8   LPF1_ReadDataReg(void) ;
uint8   LPF1_Read(void) ;
uint8   LPF1_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define LPF1_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define LPF1_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define LPF1_DM_RES_UP          PIN_DM_RES_UP
#define LPF1_DM_RES_DWN         PIN_DM_RES_DWN
#define LPF1_DM_OD_LO           PIN_DM_OD_LO
#define LPF1_DM_OD_HI           PIN_DM_OD_HI
#define LPF1_DM_STRONG          PIN_DM_STRONG
#define LPF1_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define LPF1_MASK               LPF1__MASK
#define LPF1_SHIFT              LPF1__SHIFT
#define LPF1_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define LPF1_PS                     (* (reg8 *) LPF1__PS)
/* Data Register */
#define LPF1_DR                     (* (reg8 *) LPF1__DR)
/* Port Number */
#define LPF1_PRT_NUM                (* (reg8 *) LPF1__PRT) 
/* Connect to Analog Globals */                                                  
#define LPF1_AG                     (* (reg8 *) LPF1__AG)                       
/* Analog MUX bux enable */
#define LPF1_AMUX                   (* (reg8 *) LPF1__AMUX) 
/* Bidirectional Enable */                                                        
#define LPF1_BIE                    (* (reg8 *) LPF1__BIE)
/* Bit-mask for Aliased Register Access */
#define LPF1_BIT_MASK               (* (reg8 *) LPF1__BIT_MASK)
/* Bypass Enable */
#define LPF1_BYP                    (* (reg8 *) LPF1__BYP)
/* Port wide control signals */                                                   
#define LPF1_CTL                    (* (reg8 *) LPF1__CTL)
/* Drive Modes */
#define LPF1_DM0                    (* (reg8 *) LPF1__DM0) 
#define LPF1_DM1                    (* (reg8 *) LPF1__DM1)
#define LPF1_DM2                    (* (reg8 *) LPF1__DM2) 
/* Input Buffer Disable Override */
#define LPF1_INP_DIS                (* (reg8 *) LPF1__INP_DIS)
/* LCD Common or Segment Drive */
#define LPF1_LCD_COM_SEG            (* (reg8 *) LPF1__LCD_COM_SEG)
/* Enable Segment LCD */
#define LPF1_LCD_EN                 (* (reg8 *) LPF1__LCD_EN)
/* Slew Rate Control */
#define LPF1_SLW                    (* (reg8 *) LPF1__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define LPF1_PRTDSI__CAPS_SEL       (* (reg8 *) LPF1__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define LPF1_PRTDSI__DBL_SYNC_IN    (* (reg8 *) LPF1__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define LPF1_PRTDSI__OE_SEL0        (* (reg8 *) LPF1__PRTDSI__OE_SEL0) 
#define LPF1_PRTDSI__OE_SEL1        (* (reg8 *) LPF1__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define LPF1_PRTDSI__OUT_SEL0       (* (reg8 *) LPF1__PRTDSI__OUT_SEL0) 
#define LPF1_PRTDSI__OUT_SEL1       (* (reg8 *) LPF1__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define LPF1_PRTDSI__SYNC_OUT       (* (reg8 *) LPF1__PRTDSI__SYNC_OUT) 


#if defined(LPF1__INTSTAT)  /* Interrupt Registers */

    #define LPF1_INTSTAT                (* (reg8 *) LPF1__INTSTAT)
    #define LPF1_SNAP                   (* (reg8 *) LPF1__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_LPF1_H */


/* [] END OF FILE */
