/*******************************************************************************
* File Name: PSW.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_PSW_H) /* Pins PSW_H */
#define CY_PINS_PSW_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "PSW_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 PSW__PORT == 15 && ((PSW__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    PSW_Write(uint8 value) ;
void    PSW_SetDriveMode(uint8 mode) ;
uint8   PSW_ReadDataReg(void) ;
uint8   PSW_Read(void) ;
uint8   PSW_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define PSW_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define PSW_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define PSW_DM_RES_UP          PIN_DM_RES_UP
#define PSW_DM_RES_DWN         PIN_DM_RES_DWN
#define PSW_DM_OD_LO           PIN_DM_OD_LO
#define PSW_DM_OD_HI           PIN_DM_OD_HI
#define PSW_DM_STRONG          PIN_DM_STRONG
#define PSW_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define PSW_MASK               PSW__MASK
#define PSW_SHIFT              PSW__SHIFT
#define PSW_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define PSW_PS                     (* (reg8 *) PSW__PS)
/* Data Register */
#define PSW_DR                     (* (reg8 *) PSW__DR)
/* Port Number */
#define PSW_PRT_NUM                (* (reg8 *) PSW__PRT) 
/* Connect to Analog Globals */                                                  
#define PSW_AG                     (* (reg8 *) PSW__AG)                       
/* Analog MUX bux enable */
#define PSW_AMUX                   (* (reg8 *) PSW__AMUX) 
/* Bidirectional Enable */                                                        
#define PSW_BIE                    (* (reg8 *) PSW__BIE)
/* Bit-mask for Aliased Register Access */
#define PSW_BIT_MASK               (* (reg8 *) PSW__BIT_MASK)
/* Bypass Enable */
#define PSW_BYP                    (* (reg8 *) PSW__BYP)
/* Port wide control signals */                                                   
#define PSW_CTL                    (* (reg8 *) PSW__CTL)
/* Drive Modes */
#define PSW_DM0                    (* (reg8 *) PSW__DM0) 
#define PSW_DM1                    (* (reg8 *) PSW__DM1)
#define PSW_DM2                    (* (reg8 *) PSW__DM2) 
/* Input Buffer Disable Override */
#define PSW_INP_DIS                (* (reg8 *) PSW__INP_DIS)
/* LCD Common or Segment Drive */
#define PSW_LCD_COM_SEG            (* (reg8 *) PSW__LCD_COM_SEG)
/* Enable Segment LCD */
#define PSW_LCD_EN                 (* (reg8 *) PSW__LCD_EN)
/* Slew Rate Control */
#define PSW_SLW                    (* (reg8 *) PSW__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define PSW_PRTDSI__CAPS_SEL       (* (reg8 *) PSW__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define PSW_PRTDSI__DBL_SYNC_IN    (* (reg8 *) PSW__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define PSW_PRTDSI__OE_SEL0        (* (reg8 *) PSW__PRTDSI__OE_SEL0) 
#define PSW_PRTDSI__OE_SEL1        (* (reg8 *) PSW__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define PSW_PRTDSI__OUT_SEL0       (* (reg8 *) PSW__PRTDSI__OUT_SEL0) 
#define PSW_PRTDSI__OUT_SEL1       (* (reg8 *) PSW__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define PSW_PRTDSI__SYNC_OUT       (* (reg8 *) PSW__PRTDSI__SYNC_OUT) 


#if defined(PSW__INTSTAT)  /* Interrupt Registers */

    #define PSW_INTSTAT                (* (reg8 *) PSW__INTSTAT)
    #define PSW_SNAP                   (* (reg8 *) PSW__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_PSW_H */


/* [] END OF FILE */
