/*******************************************************************************
* File Name: RE_B.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_RE_B_H) /* Pins RE_B_H */
#define CY_PINS_RE_B_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "RE_B_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_70 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 RE_B__PORT == 15 && (RE_B__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    RE_B_Write(uint8 value) ;
void    RE_B_SetDriveMode(uint8 mode) ;
uint8   RE_B_ReadDataReg(void) ;
uint8   RE_B_Read(void) ;
uint8   RE_B_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define RE_B_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define RE_B_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define RE_B_DM_RES_UP          PIN_DM_RES_UP
#define RE_B_DM_RES_DWN         PIN_DM_RES_DWN
#define RE_B_DM_OD_LO           PIN_DM_OD_LO
#define RE_B_DM_OD_HI           PIN_DM_OD_HI
#define RE_B_DM_STRONG          PIN_DM_STRONG
#define RE_B_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define RE_B_MASK               RE_B__MASK
#define RE_B_SHIFT              RE_B__SHIFT
#define RE_B_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define RE_B_PS                     (* (reg8 *) RE_B__PS)
/* Data Register */
#define RE_B_DR                     (* (reg8 *) RE_B__DR)
/* Port Number */
#define RE_B_PRT_NUM                (* (reg8 *) RE_B__PRT) 
/* Connect to Analog Globals */                                                  
#define RE_B_AG                     (* (reg8 *) RE_B__AG)                       
/* Analog MUX bux enable */
#define RE_B_AMUX                   (* (reg8 *) RE_B__AMUX) 
/* Bidirectional Enable */                                                        
#define RE_B_BIE                    (* (reg8 *) RE_B__BIE)
/* Bit-mask for Aliased Register Access */
#define RE_B_BIT_MASK               (* (reg8 *) RE_B__BIT_MASK)
/* Bypass Enable */
#define RE_B_BYP                    (* (reg8 *) RE_B__BYP)
/* Port wide control signals */                                                   
#define RE_B_CTL                    (* (reg8 *) RE_B__CTL)
/* Drive Modes */
#define RE_B_DM0                    (* (reg8 *) RE_B__DM0) 
#define RE_B_DM1                    (* (reg8 *) RE_B__DM1)
#define RE_B_DM2                    (* (reg8 *) RE_B__DM2) 
/* Input Buffer Disable Override */
#define RE_B_INP_DIS                (* (reg8 *) RE_B__INP_DIS)
/* LCD Common or Segment Drive */
#define RE_B_LCD_COM_SEG            (* (reg8 *) RE_B__LCD_COM_SEG)
/* Enable Segment LCD */
#define RE_B_LCD_EN                 (* (reg8 *) RE_B__LCD_EN)
/* Slew Rate Control */
#define RE_B_SLW                    (* (reg8 *) RE_B__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define RE_B_PRTDSI__CAPS_SEL       (* (reg8 *) RE_B__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define RE_B_PRTDSI__DBL_SYNC_IN    (* (reg8 *) RE_B__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define RE_B_PRTDSI__OE_SEL0        (* (reg8 *) RE_B__PRTDSI__OE_SEL0) 
#define RE_B_PRTDSI__OE_SEL1        (* (reg8 *) RE_B__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define RE_B_PRTDSI__OUT_SEL0       (* (reg8 *) RE_B__PRTDSI__OUT_SEL0) 
#define RE_B_PRTDSI__OUT_SEL1       (* (reg8 *) RE_B__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define RE_B_PRTDSI__SYNC_OUT       (* (reg8 *) RE_B__PRTDSI__SYNC_OUT) 


#if defined(RE_B__INTSTAT)  /* Interrupt Registers */

    #define RE_B_INTSTAT                (* (reg8 *) RE_B__INTSTAT)
    #define RE_B_SNAP                   (* (reg8 *) RE_B__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins RE_B_H */

#endif
/* [] END OF FILE */
