/*******************************************************************************
* File Name: RE_Ck1.h  
* Version 1.70
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_RE_Ck1_H) /* Pins RE_Ck1_H */
#define CY_PINS_RE_Ck1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "RE_Ck1_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_70 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 RE_Ck1__PORT == 15 && (RE_Ck1__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    RE_Ck1_Write(uint8 value) ;
void    RE_Ck1_SetDriveMode(uint8 mode) ;
uint8   RE_Ck1_ReadDataReg(void) ;
uint8   RE_Ck1_Read(void) ;
uint8   RE_Ck1_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define RE_Ck1_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define RE_Ck1_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define RE_Ck1_DM_RES_UP          PIN_DM_RES_UP
#define RE_Ck1_DM_RES_DWN         PIN_DM_RES_DWN
#define RE_Ck1_DM_OD_LO           PIN_DM_OD_LO
#define RE_Ck1_DM_OD_HI           PIN_DM_OD_HI
#define RE_Ck1_DM_STRONG          PIN_DM_STRONG
#define RE_Ck1_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define RE_Ck1_MASK               RE_Ck1__MASK
#define RE_Ck1_SHIFT              RE_Ck1__SHIFT
#define RE_Ck1_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define RE_Ck1_PS                     (* (reg8 *) RE_Ck1__PS)
/* Data Register */
#define RE_Ck1_DR                     (* (reg8 *) RE_Ck1__DR)
/* Port Number */
#define RE_Ck1_PRT_NUM                (* (reg8 *) RE_Ck1__PRT) 
/* Connect to Analog Globals */                                                  
#define RE_Ck1_AG                     (* (reg8 *) RE_Ck1__AG)                       
/* Analog MUX bux enable */
#define RE_Ck1_AMUX                   (* (reg8 *) RE_Ck1__AMUX) 
/* Bidirectional Enable */                                                        
#define RE_Ck1_BIE                    (* (reg8 *) RE_Ck1__BIE)
/* Bit-mask for Aliased Register Access */
#define RE_Ck1_BIT_MASK               (* (reg8 *) RE_Ck1__BIT_MASK)
/* Bypass Enable */
#define RE_Ck1_BYP                    (* (reg8 *) RE_Ck1__BYP)
/* Port wide control signals */                                                   
#define RE_Ck1_CTL                    (* (reg8 *) RE_Ck1__CTL)
/* Drive Modes */
#define RE_Ck1_DM0                    (* (reg8 *) RE_Ck1__DM0) 
#define RE_Ck1_DM1                    (* (reg8 *) RE_Ck1__DM1)
#define RE_Ck1_DM2                    (* (reg8 *) RE_Ck1__DM2) 
/* Input Buffer Disable Override */
#define RE_Ck1_INP_DIS                (* (reg8 *) RE_Ck1__INP_DIS)
/* LCD Common or Segment Drive */
#define RE_Ck1_LCD_COM_SEG            (* (reg8 *) RE_Ck1__LCD_COM_SEG)
/* Enable Segment LCD */
#define RE_Ck1_LCD_EN                 (* (reg8 *) RE_Ck1__LCD_EN)
/* Slew Rate Control */
#define RE_Ck1_SLW                    (* (reg8 *) RE_Ck1__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define RE_Ck1_PRTDSI__CAPS_SEL       (* (reg8 *) RE_Ck1__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define RE_Ck1_PRTDSI__DBL_SYNC_IN    (* (reg8 *) RE_Ck1__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define RE_Ck1_PRTDSI__OE_SEL0        (* (reg8 *) RE_Ck1__PRTDSI__OE_SEL0) 
#define RE_Ck1_PRTDSI__OE_SEL1        (* (reg8 *) RE_Ck1__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define RE_Ck1_PRTDSI__OUT_SEL0       (* (reg8 *) RE_Ck1__PRTDSI__OUT_SEL0) 
#define RE_Ck1_PRTDSI__OUT_SEL1       (* (reg8 *) RE_Ck1__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define RE_Ck1_PRTDSI__SYNC_OUT       (* (reg8 *) RE_Ck1__PRTDSI__SYNC_OUT) 


#if defined(RE_Ck1__INTSTAT)  /* Interrupt Registers */

    #define RE_Ck1_INTSTAT                (* (reg8 *) RE_Ck1__INTSTAT)
    #define RE_Ck1_SNAP                   (* (reg8 *) RE_Ck1__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins RE_Ck1_H */

#endif
/* [] END OF FILE */
