/*******************************************************************************
* File Name: RE_Ck2.c  
* Version 1.70
*
* Description:
*  This file contains API to enable firmware control of a Pins component.
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#include "cytypes.h"
#include "RE_Ck2.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 RE_Ck2__PORT == 15 && (RE_Ck2__MASK & 0xC0))

/*******************************************************************************
* Function Name: RE_Ck2_Write
********************************************************************************
* Summary:
*  Assign a new value to the digital port's data output register.  
*
* Parameters:  
*  prtValue:  The value to be assigned to the Digital Port. 
*
* Return: 
*  void 
*  
*******************************************************************************/
void RE_Ck2_Write(uint8 value) 
{
    uint8 staticBits = RE_Ck2_DR & ~RE_Ck2_MASK;
    RE_Ck2_DR = staticBits | ((value << RE_Ck2_SHIFT) & RE_Ck2_MASK);
}


/*******************************************************************************
* Function Name: RE_Ck2_SetDriveMode
********************************************************************************
* Summary:
*  Change the drive mode on the pins of the port.
* 
* Parameters:  
*  mode:  Change the pins to this drive mode.
*
* Return: 
*  void
*
*******************************************************************************/
void RE_Ck2_SetDriveMode(uint8 mode) 
{
	CyPins_SetPinDriveMode(RE_Ck2_0, mode);
}


/*******************************************************************************
* Function Name: RE_Ck2_Read
********************************************************************************
* Summary:
*  Read the current value on the pins of the Digital Port in right justified 
*  form.
*
* Parameters:  
*  void 
*
* Return: 
*  Returns the current value of the Digital Port as a right justified number
*  
* Note:
*  Macro RE_Ck2_ReadPS calls this function. 
*  
*******************************************************************************/
uint8 RE_Ck2_Read(void) 
{
    return (RE_Ck2_PS & RE_Ck2_MASK) >> RE_Ck2_SHIFT;
}


/*******************************************************************************
* Function Name: RE_Ck2_ReadDataReg
********************************************************************************
* Summary:
*  Read the current value assigned to a Digital Port's data output register
*
* Parameters:  
*  void 
*
* Return: 
*  Returns the current value assigned to the Digital Port's data output register
*  
*******************************************************************************/
uint8 RE_Ck2_ReadDataReg(void) 
{
    return (RE_Ck2_DR & RE_Ck2_MASK) >> RE_Ck2_SHIFT;
}


/* If Interrupts Are Enabled for this Pins component */ 
#if defined(RE_Ck2_INTSTAT) 

    /*******************************************************************************
    * Function Name: RE_Ck2_ClearInterrupt
    ********************************************************************************
    * Summary:
    *  Clears any active interrupts attached to port and returns the value of the 
    *  interrupt status register.
    *
    * Parameters:  
    *  void 
    *
    * Return: 
    *  Returns the value of the interrupt status register
    *  
    *******************************************************************************/
    uint8 RE_Ck2_ClearInterrupt(void) 
    {
        return (RE_Ck2_INTSTAT & RE_Ck2_MASK) >> RE_Ck2_SHIFT;
    }

#endif /* If Interrupts Are Enabled for this Pins component */ 

#endif
/* [] END OF FILE */ 
