/*******************************************************************************
* File Name: ReA.h  
* Version 1.60
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_ReA_H) /* Pins ReA_H */
#define CY_PINS_ReA_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "ReA_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC5 &&\
     CYDEV_CHIP_REVISION_USED == CYDEV_CHIP_REVISION_5A_PRODUCTION &&\
	 ReA__PORT == 15 && (ReA__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    ReA_Write(uint8 value) ;
void    ReA_SetDriveMode(uint8 mode) ;
uint8   ReA_ReadDataReg(void) ;
uint8   ReA_Read(void) ;
uint8   ReA_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define ReA_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define ReA_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define ReA_DM_RES_UP          PIN_DM_RES_UP
#define ReA_DM_RES_DWN         PIN_DM_RES_DWN
#define ReA_DM_OD_LO           PIN_DM_OD_LO
#define ReA_DM_OD_HI           PIN_DM_OD_HI
#define ReA_DM_STRONG          PIN_DM_STRONG
#define ReA_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define ReA_MASK               ReA__MASK
#define ReA_SHIFT              ReA__SHIFT
#define ReA_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define ReA_PS                     (* (reg8 *) ReA__PS)
/* Data Register */
#define ReA_DR                     (* (reg8 *) ReA__DR)
/* Port Number */
#define ReA_PRT_NUM                (* (reg8 *) ReA__PRT) 
/* Connect to Analog Globals */                                                  
#define ReA_AG                     (* (reg8 *) ReA__AG)                       
/* Analog MUX bux enable */
#define ReA_AMUX                   (* (reg8 *) ReA__AMUX) 
/* Bidirectional Enable */                                                        
#define ReA_BIE                    (* (reg8 *) ReA__BIE)
/* Bit-mask for Aliased Register Access */
#define ReA_BIT_MASK               (* (reg8 *) ReA__BIT_MASK)
/* Bypass Enable */
#define ReA_BYP                    (* (reg8 *) ReA__BYP)
/* Port wide control signals */                                                   
#define ReA_CTL                    (* (reg8 *) ReA__CTL)
/* Drive Modes */
#define ReA_DM0                    (* (reg8 *) ReA__DM0) 
#define ReA_DM1                    (* (reg8 *) ReA__DM1)
#define ReA_DM2                    (* (reg8 *) ReA__DM2) 
/* Input Buffer Disable Override */
#define ReA_INP_DIS                (* (reg8 *) ReA__INP_DIS)
/* LCD Common or Segment Drive */
#define ReA_LCD_COM_SEG            (* (reg8 *) ReA__LCD_COM_SEG)
/* Enable Segment LCD */
#define ReA_LCD_EN                 (* (reg8 *) ReA__LCD_EN)
/* Slew Rate Control */
#define ReA_SLW                    (* (reg8 *) ReA__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define ReA_PRTDSI__CAPS_SEL       (* (reg8 *) ReA__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define ReA_PRTDSI__DBL_SYNC_IN    (* (reg8 *) ReA__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define ReA_PRTDSI__OE_SEL0        (* (reg8 *) ReA__PRTDSI__OE_SEL0) 
#define ReA_PRTDSI__OE_SEL1        (* (reg8 *) ReA__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define ReA_PRTDSI__OUT_SEL0       (* (reg8 *) ReA__PRTDSI__OUT_SEL0) 
#define ReA_PRTDSI__OUT_SEL1       (* (reg8 *) ReA__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define ReA_PRTDSI__SYNC_OUT       (* (reg8 *) ReA__PRTDSI__SYNC_OUT) 


#if defined(ReA__INTSTAT)  /* Interrupt Registers */

    #define ReA_INTSTAT                (* (reg8 *) ReA__INTSTAT)
    #define ReA_SNAP                   (* (reg8 *) ReA__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins ReA_H */

#endif
/* [] END OF FILE */
