/*******************************************************************************
* File Name: ReB.h  
* Version 1.60
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_ReB_H) /* Pins ReB_H */
#define CY_PINS_ReB_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "ReB_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC5 &&\
     CYDEV_CHIP_REVISION_USED == CYDEV_CHIP_REVISION_5A_PRODUCTION &&\
	 ReB__PORT == 15 && (ReB__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    ReB_Write(uint8 value) ;
void    ReB_SetDriveMode(uint8 mode) ;
uint8   ReB_ReadDataReg(void) ;
uint8   ReB_Read(void) ;
uint8   ReB_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define ReB_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define ReB_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define ReB_DM_RES_UP          PIN_DM_RES_UP
#define ReB_DM_RES_DWN         PIN_DM_RES_DWN
#define ReB_DM_OD_LO           PIN_DM_OD_LO
#define ReB_DM_OD_HI           PIN_DM_OD_HI
#define ReB_DM_STRONG          PIN_DM_STRONG
#define ReB_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define ReB_MASK               ReB__MASK
#define ReB_SHIFT              ReB__SHIFT
#define ReB_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define ReB_PS                     (* (reg8 *) ReB__PS)
/* Data Register */
#define ReB_DR                     (* (reg8 *) ReB__DR)
/* Port Number */
#define ReB_PRT_NUM                (* (reg8 *) ReB__PRT) 
/* Connect to Analog Globals */                                                  
#define ReB_AG                     (* (reg8 *) ReB__AG)                       
/* Analog MUX bux enable */
#define ReB_AMUX                   (* (reg8 *) ReB__AMUX) 
/* Bidirectional Enable */                                                        
#define ReB_BIE                    (* (reg8 *) ReB__BIE)
/* Bit-mask for Aliased Register Access */
#define ReB_BIT_MASK               (* (reg8 *) ReB__BIT_MASK)
/* Bypass Enable */
#define ReB_BYP                    (* (reg8 *) ReB__BYP)
/* Port wide control signals */                                                   
#define ReB_CTL                    (* (reg8 *) ReB__CTL)
/* Drive Modes */
#define ReB_DM0                    (* (reg8 *) ReB__DM0) 
#define ReB_DM1                    (* (reg8 *) ReB__DM1)
#define ReB_DM2                    (* (reg8 *) ReB__DM2) 
/* Input Buffer Disable Override */
#define ReB_INP_DIS                (* (reg8 *) ReB__INP_DIS)
/* LCD Common or Segment Drive */
#define ReB_LCD_COM_SEG            (* (reg8 *) ReB__LCD_COM_SEG)
/* Enable Segment LCD */
#define ReB_LCD_EN                 (* (reg8 *) ReB__LCD_EN)
/* Slew Rate Control */
#define ReB_SLW                    (* (reg8 *) ReB__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define ReB_PRTDSI__CAPS_SEL       (* (reg8 *) ReB__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define ReB_PRTDSI__DBL_SYNC_IN    (* (reg8 *) ReB__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define ReB_PRTDSI__OE_SEL0        (* (reg8 *) ReB__PRTDSI__OE_SEL0) 
#define ReB_PRTDSI__OE_SEL1        (* (reg8 *) ReB__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define ReB_PRTDSI__OUT_SEL0       (* (reg8 *) ReB__PRTDSI__OUT_SEL0) 
#define ReB_PRTDSI__OUT_SEL1       (* (reg8 *) ReB__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define ReB_PRTDSI__SYNC_OUT       (* (reg8 *) ReB__PRTDSI__SYNC_OUT) 


#if defined(ReB__INTSTAT)  /* Interrupt Registers */

    #define ReB_INTSTAT                (* (reg8 *) ReB__INTSTAT)
    #define ReB_SNAP                   (* (reg8 *) ReB__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins ReB_H */

#endif
/* [] END OF FILE */
