/*******************************************************************************
* File Name: ReISR.h
* Version 1.50
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/
#if !defined(__ReISR_INTC_H__)
#define __ReISR_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void ReISR_Start(void);
void ReISR_StartEx(cyisraddress address);
void ReISR_Stop(void) ;

CY_ISR_PROTO(ReISR_Interrupt);

void ReISR_SetVector(cyisraddress address) ;
cyisraddress ReISR_GetVector(void) ;

void ReISR_SetPriority(uint8 priority) ;
uint8 ReISR_GetPriority(void) ;

void ReISR_Enable(void) ;
uint8 ReISR_GetState(void) ;
void ReISR_Disable(void) ;

void ReISR_SetPending(void) ;
void ReISR_ClearPending(void) ;


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the ReISR ISR. */
#define ReISR_INTC_VECTOR            ((reg32 *) ReISR__INTC_VECT)

/* Address of the ReISR ISR priority. */
#define ReISR_INTC_PRIOR             ((reg8 *) ReISR__INTC_PRIOR_REG)

/* Priority of the ReISR interrupt. */
#define ReISR_INTC_PRIOR_NUMBER      ReISR__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable ReISR interrupt. */
#define ReISR_INTC_SET_EN            ((reg32 *) ReISR__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the ReISR interrupt. */
#define ReISR_INTC_CLR_EN            ((reg32 *) ReISR__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the ReISR interrupt state to pending. */
#define ReISR_INTC_SET_PD            ((reg32 *) ReISR__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the ReISR interrupt. */
#define ReISR_INTC_CLR_PD            ((reg32 *) ReISR__INTC_CLR_PD_REG)



/* __ReISR_INTC_H__ */
#endif
