/*******************************************************************************
* File Name: RotaryEncoder_1_B.h  
* Version 1.60
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_RotaryEncoder_1_B_H) /* Pins RotaryEncoder_1_B_H */
#define CY_PINS_RotaryEncoder_1_B_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "RotaryEncoder_1_B_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC5 &&\
     CYDEV_CHIP_REVISION_USED == CYDEV_CHIP_REVISION_5A_PRODUCTION &&\
	 RotaryEncoder_1_B__PORT == 15 && (RotaryEncoder_1_B__MASK & 0xC0))

/***************************************
*        Function Prototypes             
***************************************/    

void    RotaryEncoder_1_B_Write(uint8 value) ;
void    RotaryEncoder_1_B_SetDriveMode(uint8 mode) ;
uint8   RotaryEncoder_1_B_ReadDataReg(void) ;
uint8   RotaryEncoder_1_B_Read(void) ;
uint8   RotaryEncoder_1_B_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define RotaryEncoder_1_B_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define RotaryEncoder_1_B_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define RotaryEncoder_1_B_DM_RES_UP          PIN_DM_RES_UP
#define RotaryEncoder_1_B_DM_RES_DWN         PIN_DM_RES_DWN
#define RotaryEncoder_1_B_DM_OD_LO           PIN_DM_OD_LO
#define RotaryEncoder_1_B_DM_OD_HI           PIN_DM_OD_HI
#define RotaryEncoder_1_B_DM_STRONG          PIN_DM_STRONG
#define RotaryEncoder_1_B_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define RotaryEncoder_1_B_MASK               RotaryEncoder_1_B__MASK
#define RotaryEncoder_1_B_SHIFT              RotaryEncoder_1_B__SHIFT
#define RotaryEncoder_1_B_WIDTH              1u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define RotaryEncoder_1_B_PS                     (* (reg8 *) RotaryEncoder_1_B__PS)
/* Data Register */
#define RotaryEncoder_1_B_DR                     (* (reg8 *) RotaryEncoder_1_B__DR)
/* Port Number */
#define RotaryEncoder_1_B_PRT_NUM                (* (reg8 *) RotaryEncoder_1_B__PRT) 
/* Connect to Analog Globals */                                                  
#define RotaryEncoder_1_B_AG                     (* (reg8 *) RotaryEncoder_1_B__AG)                       
/* Analog MUX bux enable */
#define RotaryEncoder_1_B_AMUX                   (* (reg8 *) RotaryEncoder_1_B__AMUX) 
/* Bidirectional Enable */                                                        
#define RotaryEncoder_1_B_BIE                    (* (reg8 *) RotaryEncoder_1_B__BIE)
/* Bit-mask for Aliased Register Access */
#define RotaryEncoder_1_B_BIT_MASK               (* (reg8 *) RotaryEncoder_1_B__BIT_MASK)
/* Bypass Enable */
#define RotaryEncoder_1_B_BYP                    (* (reg8 *) RotaryEncoder_1_B__BYP)
/* Port wide control signals */                                                   
#define RotaryEncoder_1_B_CTL                    (* (reg8 *) RotaryEncoder_1_B__CTL)
/* Drive Modes */
#define RotaryEncoder_1_B_DM0                    (* (reg8 *) RotaryEncoder_1_B__DM0) 
#define RotaryEncoder_1_B_DM1                    (* (reg8 *) RotaryEncoder_1_B__DM1)
#define RotaryEncoder_1_B_DM2                    (* (reg8 *) RotaryEncoder_1_B__DM2) 
/* Input Buffer Disable Override */
#define RotaryEncoder_1_B_INP_DIS                (* (reg8 *) RotaryEncoder_1_B__INP_DIS)
/* LCD Common or Segment Drive */
#define RotaryEncoder_1_B_LCD_COM_SEG            (* (reg8 *) RotaryEncoder_1_B__LCD_COM_SEG)
/* Enable Segment LCD */
#define RotaryEncoder_1_B_LCD_EN                 (* (reg8 *) RotaryEncoder_1_B__LCD_EN)
/* Slew Rate Control */
#define RotaryEncoder_1_B_SLW                    (* (reg8 *) RotaryEncoder_1_B__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define RotaryEncoder_1_B_PRTDSI__CAPS_SEL       (* (reg8 *) RotaryEncoder_1_B__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define RotaryEncoder_1_B_PRTDSI__DBL_SYNC_IN    (* (reg8 *) RotaryEncoder_1_B__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define RotaryEncoder_1_B_PRTDSI__OE_SEL0        (* (reg8 *) RotaryEncoder_1_B__PRTDSI__OE_SEL0) 
#define RotaryEncoder_1_B_PRTDSI__OE_SEL1        (* (reg8 *) RotaryEncoder_1_B__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define RotaryEncoder_1_B_PRTDSI__OUT_SEL0       (* (reg8 *) RotaryEncoder_1_B__PRTDSI__OUT_SEL0) 
#define RotaryEncoder_1_B_PRTDSI__OUT_SEL1       (* (reg8 *) RotaryEncoder_1_B__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define RotaryEncoder_1_B_PRTDSI__SYNC_OUT       (* (reg8 *) RotaryEncoder_1_B__PRTDSI__SYNC_OUT) 


#if defined(RotaryEncoder_1_B__INTSTAT)  /* Interrupt Registers */

    #define RotaryEncoder_1_B_INTSTAT                (* (reg8 *) RotaryEncoder_1_B__INTSTAT)
    #define RotaryEncoder_1_B_SNAP                   (* (reg8 *) RotaryEncoder_1_B__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins RotaryEncoder_1_B_H */

#endif
/* [] END OF FILE */
