/*******************************************************************************
* File Name: RotaryEncoder_1_ISR.c  
* Version 1.50
*
*  Description:
*   API for controlling the state of an interrupt.
*
*
*  Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/


#include <CYDEVICE.H>
#include <CYDEVICE_TRM.H>
#include <CYLIB.H>
#include <RotaryEncoder_1_ISR.H>


/*******************************************************************************
*  Place your includes, defines and code here 
********************************************************************************/
/* `#START RotaryEncoder_1_ISR_intc` */

/* `#END` */

#ifndef CYINT_IRQ_BASE
#define CYINT_IRQ_BASE	16
#endif
#ifndef CYINT_VECT_TABLE
#define CYINT_VECT_TABLE    ((cyisraddress **) CYREG_NVIC_VECT_OFFSET)
#endif

/* Declared in startup, used to set unused interrupts to. */
CY_ISR_PROTO(IntDefaultHandler);

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_Start
********************************************************************************
* Summary:
*  Set up the interrupt and enable it.
*
* Parameters:  
*   void.
*
*
* Return:
*   void.
*
*******************************************************************************/
void RotaryEncoder_1_ISR_Start(void)
{
    /* For all we know the interrupt is active. */
    RotaryEncoder_1_ISR_Disable();

    /* Set the ISR to point to the RotaryEncoder_1_ISR Interrupt. */
    RotaryEncoder_1_ISR_SetVector(RotaryEncoder_1_ISR_Interrupt);

    /* Set the priority. */
    RotaryEncoder_1_ISR_SetPriority(RotaryEncoder_1_ISR_INTC_PRIOR_NUMBER);

    /* Enable it. */
    RotaryEncoder_1_ISR_Enable();
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_StartEx
********************************************************************************
* Summary:
*  Set up the interrupt and enable it.
*
* Parameters:  
*   address: Address of the ISR to set in the interrupt vector table.
*
*
* Return:
*   void.
*
*******************************************************************************/
void RotaryEncoder_1_ISR_StartEx(cyisraddress address)
{
    /* For all we know the interrupt is active. */
    RotaryEncoder_1_ISR_Disable();

    /* Set the ISR to point to the RotaryEncoder_1_ISR Interrupt. */
    RotaryEncoder_1_ISR_SetVector(address);

    /* Set the priority. */
    RotaryEncoder_1_ISR_SetPriority(RotaryEncoder_1_ISR_INTC_PRIOR_NUMBER);

    /* Enable it. */
    RotaryEncoder_1_ISR_Enable();
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_Stop
********************************************************************************
* Summary:
*   Disables and removes the interrupt.
*
* Parameters:  
*
*
* Return:
*   void.
*
*******************************************************************************/
void RotaryEncoder_1_ISR_Stop(void) 
{
    /* Disable this interrupt. */
    RotaryEncoder_1_ISR_Disable();

    /* Set the ISR to point to the passive one. */
    RotaryEncoder_1_ISR_SetVector(IntDefaultHandler);
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_Interrupt
********************************************************************************
* Summary:
*   The default Interrupt Service Routine for RotaryEncoder_1_ISR.
*
*   Add custom code between the coments to keep the next version of this file
*   from over writting your code.
*
*
*
* Parameters:  
*
*
* Return:
*   void.
*
*******************************************************************************/
CY_ISR(RotaryEncoder_1_ISR_Interrupt)
{
    /*  Place your Interrupt code here. */
    /* `#START RotaryEncoder_1_ISR_Interrupt` */

    /* `#END` */
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_SetVector
********************************************************************************
* Summary:
*   Change the ISR vector for the Interrupt. Note calling RotaryEncoder_1_ISR_Start
*   will override any effect this method would have had. To set the vector before
*   the component has been started use RotaryEncoder_1_ISR_StartEx instead.
*
*
* Parameters:
*   address: Address of the ISR to set in the interrupt vector table.
*
*
* Return:
*   void.
*
*
*******************************************************************************/
void RotaryEncoder_1_ISR_SetVector(cyisraddress address) 
{
    cyisraddress * ramVectorTable;

    ramVectorTable = (cyisraddress *) *CYINT_VECT_TABLE;

    ramVectorTable[CYINT_IRQ_BASE + RotaryEncoder_1_ISR__INTC_NUMBER] = address;
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_GetVector
********************************************************************************
* Summary:
*   Gets the "address" of the current ISR vector for the Interrupt.
*
*
* Parameters:
*   void.
*
*
* Return:
*   Address of the ISR in the interrupt vector table.
*
*
*******************************************************************************/
cyisraddress RotaryEncoder_1_ISR_GetVector(void) 
{
    cyisraddress * ramVectorTable;

    ramVectorTable = (cyisraddress *) *CYINT_VECT_TABLE;

    return ramVectorTable[CYINT_IRQ_BASE + RotaryEncoder_1_ISR__INTC_NUMBER];
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_SetPriority
********************************************************************************
* Summary:
*   Sets the Priority of the Interrupt. Note calling RotaryEncoder_1_ISR_Start
*   or RotaryEncoder_1_ISR_StartEx will override any effect this method would have had. 
*	This method should only be called after RotaryEncoder_1_ISR_Start or 
*	RotaryEncoder_1_ISR_StartEx has been called. To set the initial
*	priority for the component use the cydwr file in the tool.
*
*
* Parameters:
*   priority: Priority of the interrupt. 0 - 7, 0 being the highest.
*
*
* Return:
*   void.
*
*
*******************************************************************************/
void RotaryEncoder_1_ISR_SetPriority(uint8 priority) 
{
    *RotaryEncoder_1_ISR_INTC_PRIOR = priority << 5;
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_GetPriority
********************************************************************************
* Summary:
*   Gets the Priority of the Interrupt.
*
*
* Parameters:
*   void.
*
*
* Return:
*   Priority of the interrupt. 0 - 7, 0 being the highest.
*
*
*******************************************************************************/
uint8 RotaryEncoder_1_ISR_GetPriority(void) 
{
    uint8 priority;


    priority = *RotaryEncoder_1_ISR_INTC_PRIOR >> 5;

    return priority;
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_Enable
********************************************************************************
* Summary:
*   Enables the interrupt.
*
*
* Parameters:
*   void.
*
*
* Return:
*   void.
*
*
*******************************************************************************/
void RotaryEncoder_1_ISR_Enable(void) 
{
    /* Enable the general interrupt. */
    *RotaryEncoder_1_ISR_INTC_SET_EN = RotaryEncoder_1_ISR__INTC_MASK;
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_GetState
********************************************************************************
* Summary:
*   Gets the state (enabled, disabled) of the Interrupt.
*
*
* Parameters:
*   void.
*
*
* Return:
*   1 if enabled, 0 if disabled.
*
*
*******************************************************************************/
uint8 RotaryEncoder_1_ISR_GetState(void) 
{
    /* Get the state of the general interrupt. */
    return (*RotaryEncoder_1_ISR_INTC_SET_EN & RotaryEncoder_1_ISR__INTC_MASK) ? 1:0;
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_Disable
********************************************************************************
* Summary:
*   Disables the Interrupt.
*
*
* Parameters:
*   void.
*
*
* Return:
*   void.
*
*
*******************************************************************************/
void RotaryEncoder_1_ISR_Disable(void) 
{
    /* Disable the general interrupt. */
    *RotaryEncoder_1_ISR_INTC_CLR_EN = RotaryEncoder_1_ISR__INTC_MASK;
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_SetPending
********************************************************************************
* Summary:
*   Causes the Interrupt to enter the pending state, a software method of
*   generating the interrupt.
*
*
* Parameters:
*   void.
*
*
* Return:
*   void.
*
*
*******************************************************************************/
void RotaryEncoder_1_ISR_SetPending(void) 
{
    *RotaryEncoder_1_ISR_INTC_SET_PD = RotaryEncoder_1_ISR__INTC_MASK;
}

/*******************************************************************************
* Function Name: RotaryEncoder_1_ISR_ClearPending
********************************************************************************
* Summary:
*   Clears a pending interrupt.
*
* Parameters:
*   void.
*
*
* Return:
*   void.
*
*
*******************************************************************************/
void RotaryEncoder_1_ISR_ClearPending(void) 
{
    *RotaryEncoder_1_ISR_INTC_CLR_PD = RotaryEncoder_1_ISR__INTC_MASK;
}
