/*******************************************************************************
* File Name: RotaryEncoder_1_ISR.h
* Version 1.50
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/
#if !defined(__RotaryEncoder_1_ISR_INTC_H__)
#define __RotaryEncoder_1_ISR_INTC_H__


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void RotaryEncoder_1_ISR_Start(void);
void RotaryEncoder_1_ISR_StartEx(cyisraddress address);
void RotaryEncoder_1_ISR_Stop(void) ;

CY_ISR_PROTO(RotaryEncoder_1_ISR_Interrupt);

void RotaryEncoder_1_ISR_SetVector(cyisraddress address) ;
cyisraddress RotaryEncoder_1_ISR_GetVector(void) ;

void RotaryEncoder_1_ISR_SetPriority(uint8 priority) ;
uint8 RotaryEncoder_1_ISR_GetPriority(void) ;

void RotaryEncoder_1_ISR_Enable(void) ;
uint8 RotaryEncoder_1_ISR_GetState(void) ;
void RotaryEncoder_1_ISR_Disable(void) ;

void RotaryEncoder_1_ISR_SetPending(void) ;
void RotaryEncoder_1_ISR_ClearPending(void) ;


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the RotaryEncoder_1_ISR ISR. */
#define RotaryEncoder_1_ISR_INTC_VECTOR            ((reg32 *) RotaryEncoder_1_ISR__INTC_VECT)

/* Address of the RotaryEncoder_1_ISR ISR priority. */
#define RotaryEncoder_1_ISR_INTC_PRIOR             ((reg8 *) RotaryEncoder_1_ISR__INTC_PRIOR_REG)

/* Priority of the RotaryEncoder_1_ISR interrupt. */
#define RotaryEncoder_1_ISR_INTC_PRIOR_NUMBER      RotaryEncoder_1_ISR__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable RotaryEncoder_1_ISR interrupt. */
#define RotaryEncoder_1_ISR_INTC_SET_EN            ((reg32 *) RotaryEncoder_1_ISR__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the RotaryEncoder_1_ISR interrupt. */
#define RotaryEncoder_1_ISR_INTC_CLR_EN            ((reg32 *) RotaryEncoder_1_ISR__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the RotaryEncoder_1_ISR interrupt state to pending. */
#define RotaryEncoder_1_ISR_INTC_SET_PD            ((reg32 *) RotaryEncoder_1_ISR__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the RotaryEncoder_1_ISR interrupt. */
#define RotaryEncoder_1_ISR_INTC_CLR_PD            ((reg32 *) RotaryEncoder_1_ISR__INTC_CLR_PD_REG)



/* __RotaryEncoder_1_ISR_INTC_H__ */
#endif
