/*******************************************************************************
* File Name: TP2.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_TP2_H) /* Pins TP2_H */
#define CY_PINS_TP2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "TP2_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 TP2__PORT == 15 && ((TP2__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    TP2_Write(uint8 value) ;
void    TP2_SetDriveMode(uint8 mode) ;
uint8   TP2_ReadDataReg(void) ;
uint8   TP2_Read(void) ;
uint8   TP2_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define TP2_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define TP2_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define TP2_DM_RES_UP          PIN_DM_RES_UP
#define TP2_DM_RES_DWN         PIN_DM_RES_DWN
#define TP2_DM_OD_LO           PIN_DM_OD_LO
#define TP2_DM_OD_HI           PIN_DM_OD_HI
#define TP2_DM_STRONG          PIN_DM_STRONG
#define TP2_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define TP2_MASK               TP2__MASK
#define TP2_SHIFT              TP2__SHIFT
#define TP2_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define TP2_PS                     (* (reg8 *) TP2__PS)
/* Data Register */
#define TP2_DR                     (* (reg8 *) TP2__DR)
/* Port Number */
#define TP2_PRT_NUM                (* (reg8 *) TP2__PRT) 
/* Connect to Analog Globals */                                                  
#define TP2_AG                     (* (reg8 *) TP2__AG)                       
/* Analog MUX bux enable */
#define TP2_AMUX                   (* (reg8 *) TP2__AMUX) 
/* Bidirectional Enable */                                                        
#define TP2_BIE                    (* (reg8 *) TP2__BIE)
/* Bit-mask for Aliased Register Access */
#define TP2_BIT_MASK               (* (reg8 *) TP2__BIT_MASK)
/* Bypass Enable */
#define TP2_BYP                    (* (reg8 *) TP2__BYP)
/* Port wide control signals */                                                   
#define TP2_CTL                    (* (reg8 *) TP2__CTL)
/* Drive Modes */
#define TP2_DM0                    (* (reg8 *) TP2__DM0) 
#define TP2_DM1                    (* (reg8 *) TP2__DM1)
#define TP2_DM2                    (* (reg8 *) TP2__DM2) 
/* Input Buffer Disable Override */
#define TP2_INP_DIS                (* (reg8 *) TP2__INP_DIS)
/* LCD Common or Segment Drive */
#define TP2_LCD_COM_SEG            (* (reg8 *) TP2__LCD_COM_SEG)
/* Enable Segment LCD */
#define TP2_LCD_EN                 (* (reg8 *) TP2__LCD_EN)
/* Slew Rate Control */
#define TP2_SLW                    (* (reg8 *) TP2__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define TP2_PRTDSI__CAPS_SEL       (* (reg8 *) TP2__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define TP2_PRTDSI__DBL_SYNC_IN    (* (reg8 *) TP2__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define TP2_PRTDSI__OE_SEL0        (* (reg8 *) TP2__PRTDSI__OE_SEL0) 
#define TP2_PRTDSI__OE_SEL1        (* (reg8 *) TP2__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define TP2_PRTDSI__OUT_SEL0       (* (reg8 *) TP2__PRTDSI__OUT_SEL0) 
#define TP2_PRTDSI__OUT_SEL1       (* (reg8 *) TP2__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define TP2_PRTDSI__SYNC_OUT       (* (reg8 *) TP2__PRTDSI__SYNC_OUT) 


#if defined(TP2__INTSTAT)  /* Interrupt Registers */

    #define TP2_INTSTAT                (* (reg8 *) TP2__INTSTAT)
    #define TP2_SNAP                   (* (reg8 *) TP2__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_TP2_H */


/* [] END OF FILE */
