/*******************************************************************************
* File Name: XckOp.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_XckOp_H) /* Pins XckOp_H */
#define CY_PINS_XckOp_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "XckOp_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 XckOp__PORT == 15 && ((XckOp__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    XckOp_Write(uint8 value) ;
void    XckOp_SetDriveMode(uint8 mode) ;
uint8   XckOp_ReadDataReg(void) ;
uint8   XckOp_Read(void) ;
uint8   XckOp_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define XckOp_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define XckOp_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define XckOp_DM_RES_UP          PIN_DM_RES_UP
#define XckOp_DM_RES_DWN         PIN_DM_RES_DWN
#define XckOp_DM_OD_LO           PIN_DM_OD_LO
#define XckOp_DM_OD_HI           PIN_DM_OD_HI
#define XckOp_DM_STRONG          PIN_DM_STRONG
#define XckOp_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define XckOp_MASK               XckOp__MASK
#define XckOp_SHIFT              XckOp__SHIFT
#define XckOp_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define XckOp_PS                     (* (reg8 *) XckOp__PS)
/* Data Register */
#define XckOp_DR                     (* (reg8 *) XckOp__DR)
/* Port Number */
#define XckOp_PRT_NUM                (* (reg8 *) XckOp__PRT) 
/* Connect to Analog Globals */                                                  
#define XckOp_AG                     (* (reg8 *) XckOp__AG)                       
/* Analog MUX bux enable */
#define XckOp_AMUX                   (* (reg8 *) XckOp__AMUX) 
/* Bidirectional Enable */                                                        
#define XckOp_BIE                    (* (reg8 *) XckOp__BIE)
/* Bit-mask for Aliased Register Access */
#define XckOp_BIT_MASK               (* (reg8 *) XckOp__BIT_MASK)
/* Bypass Enable */
#define XckOp_BYP                    (* (reg8 *) XckOp__BYP)
/* Port wide control signals */                                                   
#define XckOp_CTL                    (* (reg8 *) XckOp__CTL)
/* Drive Modes */
#define XckOp_DM0                    (* (reg8 *) XckOp__DM0) 
#define XckOp_DM1                    (* (reg8 *) XckOp__DM1)
#define XckOp_DM2                    (* (reg8 *) XckOp__DM2) 
/* Input Buffer Disable Override */
#define XckOp_INP_DIS                (* (reg8 *) XckOp__INP_DIS)
/* LCD Common or Segment Drive */
#define XckOp_LCD_COM_SEG            (* (reg8 *) XckOp__LCD_COM_SEG)
/* Enable Segment LCD */
#define XckOp_LCD_EN                 (* (reg8 *) XckOp__LCD_EN)
/* Slew Rate Control */
#define XckOp_SLW                    (* (reg8 *) XckOp__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define XckOp_PRTDSI__CAPS_SEL       (* (reg8 *) XckOp__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define XckOp_PRTDSI__DBL_SYNC_IN    (* (reg8 *) XckOp__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define XckOp_PRTDSI__OE_SEL0        (* (reg8 *) XckOp__PRTDSI__OE_SEL0) 
#define XckOp_PRTDSI__OE_SEL1        (* (reg8 *) XckOp__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define XckOp_PRTDSI__OUT_SEL0       (* (reg8 *) XckOp__PRTDSI__OUT_SEL0) 
#define XckOp_PRTDSI__OUT_SEL1       (* (reg8 *) XckOp__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define XckOp_PRTDSI__SYNC_OUT       (* (reg8 *) XckOp__PRTDSI__SYNC_OUT) 


#if defined(XckOp__INTSTAT)  /* Interrupt Registers */

    #define XckOp_INTSTAT                (* (reg8 *) XckOp__INTSTAT)
    #define XckOp_SNAP                   (* (reg8 *) XckOp__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_XckOp_H */


/* [] END OF FILE */
