/*******************************************************************************
* File Name: Xclk.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Xclk_H) /* Pins Xclk_H */
#define CY_PINS_Xclk_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Xclk_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Xclk__PORT == 15 && ((Xclk__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    Xclk_Write(uint8 value) ;
void    Xclk_SetDriveMode(uint8 mode) ;
uint8   Xclk_ReadDataReg(void) ;
uint8   Xclk_Read(void) ;
uint8   Xclk_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Xclk_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Xclk_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Xclk_DM_RES_UP          PIN_DM_RES_UP
#define Xclk_DM_RES_DWN         PIN_DM_RES_DWN
#define Xclk_DM_OD_LO           PIN_DM_OD_LO
#define Xclk_DM_OD_HI           PIN_DM_OD_HI
#define Xclk_DM_STRONG          PIN_DM_STRONG
#define Xclk_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Xclk_MASK               Xclk__MASK
#define Xclk_SHIFT              Xclk__SHIFT
#define Xclk_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Xclk_PS                     (* (reg8 *) Xclk__PS)
/* Data Register */
#define Xclk_DR                     (* (reg8 *) Xclk__DR)
/* Port Number */
#define Xclk_PRT_NUM                (* (reg8 *) Xclk__PRT) 
/* Connect to Analog Globals */                                                  
#define Xclk_AG                     (* (reg8 *) Xclk__AG)                       
/* Analog MUX bux enable */
#define Xclk_AMUX                   (* (reg8 *) Xclk__AMUX) 
/* Bidirectional Enable */                                                        
#define Xclk_BIE                    (* (reg8 *) Xclk__BIE)
/* Bit-mask for Aliased Register Access */
#define Xclk_BIT_MASK               (* (reg8 *) Xclk__BIT_MASK)
/* Bypass Enable */
#define Xclk_BYP                    (* (reg8 *) Xclk__BYP)
/* Port wide control signals */                                                   
#define Xclk_CTL                    (* (reg8 *) Xclk__CTL)
/* Drive Modes */
#define Xclk_DM0                    (* (reg8 *) Xclk__DM0) 
#define Xclk_DM1                    (* (reg8 *) Xclk__DM1)
#define Xclk_DM2                    (* (reg8 *) Xclk__DM2) 
/* Input Buffer Disable Override */
#define Xclk_INP_DIS                (* (reg8 *) Xclk__INP_DIS)
/* LCD Common or Segment Drive */
#define Xclk_LCD_COM_SEG            (* (reg8 *) Xclk__LCD_COM_SEG)
/* Enable Segment LCD */
#define Xclk_LCD_EN                 (* (reg8 *) Xclk__LCD_EN)
/* Slew Rate Control */
#define Xclk_SLW                    (* (reg8 *) Xclk__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Xclk_PRTDSI__CAPS_SEL       (* (reg8 *) Xclk__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Xclk_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Xclk__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Xclk_PRTDSI__OE_SEL0        (* (reg8 *) Xclk__PRTDSI__OE_SEL0) 
#define Xclk_PRTDSI__OE_SEL1        (* (reg8 *) Xclk__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Xclk_PRTDSI__OUT_SEL0       (* (reg8 *) Xclk__PRTDSI__OUT_SEL0) 
#define Xclk_PRTDSI__OUT_SEL1       (* (reg8 *) Xclk__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Xclk_PRTDSI__SYNC_OUT       (* (reg8 *) Xclk__PRTDSI__SYNC_OUT) 


#if defined(Xclk__INTSTAT)  /* Interrupt Registers */

    #define Xclk_INTSTAT                (* (reg8 *) Xclk__INTSTAT)
    #define Xclk_SNAP                   (* (reg8 *) Xclk__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Xclk_H */


/* [] END OF FILE */
