/*******************************************************************************
* File Name: Xout.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Xout_H) /* Pins Xout_H */
#define CY_PINS_Xout_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Xout_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Xout__PORT == 15 && ((Xout__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    Xout_Write(uint8 value) ;
void    Xout_SetDriveMode(uint8 mode) ;
uint8   Xout_ReadDataReg(void) ;
uint8   Xout_Read(void) ;
uint8   Xout_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Xout_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Xout_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Xout_DM_RES_UP          PIN_DM_RES_UP
#define Xout_DM_RES_DWN         PIN_DM_RES_DWN
#define Xout_DM_OD_LO           PIN_DM_OD_LO
#define Xout_DM_OD_HI           PIN_DM_OD_HI
#define Xout_DM_STRONG          PIN_DM_STRONG
#define Xout_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Xout_MASK               Xout__MASK
#define Xout_SHIFT              Xout__SHIFT
#define Xout_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Xout_PS                     (* (reg8 *) Xout__PS)
/* Data Register */
#define Xout_DR                     (* (reg8 *) Xout__DR)
/* Port Number */
#define Xout_PRT_NUM                (* (reg8 *) Xout__PRT) 
/* Connect to Analog Globals */                                                  
#define Xout_AG                     (* (reg8 *) Xout__AG)                       
/* Analog MUX bux enable */
#define Xout_AMUX                   (* (reg8 *) Xout__AMUX) 
/* Bidirectional Enable */                                                        
#define Xout_BIE                    (* (reg8 *) Xout__BIE)
/* Bit-mask for Aliased Register Access */
#define Xout_BIT_MASK               (* (reg8 *) Xout__BIT_MASK)
/* Bypass Enable */
#define Xout_BYP                    (* (reg8 *) Xout__BYP)
/* Port wide control signals */                                                   
#define Xout_CTL                    (* (reg8 *) Xout__CTL)
/* Drive Modes */
#define Xout_DM0                    (* (reg8 *) Xout__DM0) 
#define Xout_DM1                    (* (reg8 *) Xout__DM1)
#define Xout_DM2                    (* (reg8 *) Xout__DM2) 
/* Input Buffer Disable Override */
#define Xout_INP_DIS                (* (reg8 *) Xout__INP_DIS)
/* LCD Common or Segment Drive */
#define Xout_LCD_COM_SEG            (* (reg8 *) Xout__LCD_COM_SEG)
/* Enable Segment LCD */
#define Xout_LCD_EN                 (* (reg8 *) Xout__LCD_EN)
/* Slew Rate Control */
#define Xout_SLW                    (* (reg8 *) Xout__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Xout_PRTDSI__CAPS_SEL       (* (reg8 *) Xout__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Xout_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Xout__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Xout_PRTDSI__OE_SEL0        (* (reg8 *) Xout__PRTDSI__OE_SEL0) 
#define Xout_PRTDSI__OE_SEL1        (* (reg8 *) Xout__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Xout_PRTDSI__OUT_SEL0       (* (reg8 *) Xout__PRTDSI__OUT_SEL0) 
#define Xout_PRTDSI__OUT_SEL1       (* (reg8 *) Xout__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Xout_PRTDSI__SYNC_OUT       (* (reg8 *) Xout__PRTDSI__SYNC_OUT) 


#if defined(Xout__INTSTAT)  /* Interrupt Registers */

    #define Xout_INTSTAT                (* (reg8 *) Xout__INTSTAT)
    #define Xout_SNAP                   (* (reg8 *) Xout__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Xout_H */


/* [] END OF FILE */
