/*******************************************************************************
* File Name: Yout.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Yout_H) /* Pins Yout_H */
#define CY_PINS_Yout_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Yout_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Yout__PORT == 15 && ((Yout__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    Yout_Write(uint8 value) ;
void    Yout_SetDriveMode(uint8 mode) ;
uint8   Yout_ReadDataReg(void) ;
uint8   Yout_Read(void) ;
uint8   Yout_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Yout_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Yout_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Yout_DM_RES_UP          PIN_DM_RES_UP
#define Yout_DM_RES_DWN         PIN_DM_RES_DWN
#define Yout_DM_OD_LO           PIN_DM_OD_LO
#define Yout_DM_OD_HI           PIN_DM_OD_HI
#define Yout_DM_STRONG          PIN_DM_STRONG
#define Yout_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Yout_MASK               Yout__MASK
#define Yout_SHIFT              Yout__SHIFT
#define Yout_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Yout_PS                     (* (reg8 *) Yout__PS)
/* Data Register */
#define Yout_DR                     (* (reg8 *) Yout__DR)
/* Port Number */
#define Yout_PRT_NUM                (* (reg8 *) Yout__PRT) 
/* Connect to Analog Globals */                                                  
#define Yout_AG                     (* (reg8 *) Yout__AG)                       
/* Analog MUX bux enable */
#define Yout_AMUX                   (* (reg8 *) Yout__AMUX) 
/* Bidirectional Enable */                                                        
#define Yout_BIE                    (* (reg8 *) Yout__BIE)
/* Bit-mask for Aliased Register Access */
#define Yout_BIT_MASK               (* (reg8 *) Yout__BIT_MASK)
/* Bypass Enable */
#define Yout_BYP                    (* (reg8 *) Yout__BYP)
/* Port wide control signals */                                                   
#define Yout_CTL                    (* (reg8 *) Yout__CTL)
/* Drive Modes */
#define Yout_DM0                    (* (reg8 *) Yout__DM0) 
#define Yout_DM1                    (* (reg8 *) Yout__DM1)
#define Yout_DM2                    (* (reg8 *) Yout__DM2) 
/* Input Buffer Disable Override */
#define Yout_INP_DIS                (* (reg8 *) Yout__INP_DIS)
/* LCD Common or Segment Drive */
#define Yout_LCD_COM_SEG            (* (reg8 *) Yout__LCD_COM_SEG)
/* Enable Segment LCD */
#define Yout_LCD_EN                 (* (reg8 *) Yout__LCD_EN)
/* Slew Rate Control */
#define Yout_SLW                    (* (reg8 *) Yout__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Yout_PRTDSI__CAPS_SEL       (* (reg8 *) Yout__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Yout_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Yout__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Yout_PRTDSI__OE_SEL0        (* (reg8 *) Yout__PRTDSI__OE_SEL0) 
#define Yout_PRTDSI__OE_SEL1        (* (reg8 *) Yout__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Yout_PRTDSI__OUT_SEL0       (* (reg8 *) Yout__PRTDSI__OUT_SEL0) 
#define Yout_PRTDSI__OUT_SEL1       (* (reg8 *) Yout__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Yout_PRTDSI__SYNC_OUT       (* (reg8 *) Yout__PRTDSI__SYNC_OUT) 


#if defined(Yout__INTSTAT)  /* Interrupt Registers */

    #define Yout_INTSTAT                (* (reg8 *) Yout__INTSTAT)
    #define Yout_SNAP                   (* (reg8 *) Yout__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Yout_H */


/* [] END OF FILE */
